package sun.java2d.loops;

import sun.java2d.pipe.SpanIterator;
import java.awt.image.ColorModel;
import java.awt.image.WritableRaster;
import sun.awt.image.IntegerComponentRaster;
import sun.java2d.pipe.Region;
import java.awt.Composite;
import sun.java2d.SurfaceData;

class OpaqueCopyArgbToAny extends Blit
{
    OpaqueCopyArgbToAny() {
        super(SurfaceType.IntArgb, CompositeType.SrcNoEa, SurfaceType.Any);
    }
    
    @Override
    public void Blit(SurfaceData surfaceData, SurfaceData surfaceData2, Composite composite, Region region, int n, int n2, int n3, int n4, int n5, int n6) {
        IntegerComponentRaster integerComponentRaster = (IntegerComponentRaster)surfaceData.getRaster(n, n2, n5, n6);
        int[] dataStorage = integerComponentRaster.getDataStorage();
        WritableRaster writableRaster = (WritableRaster)surfaceData2.getRaster(n3, n4, n5, n6);
        ColorModel colorModel = surfaceData2.getColorModel();
        SpanIterator spanIterator = CustomComponent.getRegionOfInterest(surfaceData, surfaceData2, region, n, n2, n3, n4, n5, n6).getSpanIterator();
        Object dataElements = null;
        int scanlineStride = integerComponentRaster.getScanlineStride();
        n -= n3;
        n2 -= n4;
        int[] array = new int[4];
        while (spanIterator.nextSpan(array)) {
            for (int n7 = integerComponentRaster.getDataOffset(0) + (n2 + array[1]) * scanlineStride + (n + array[0]), i = array[1]; i < array[3]; n7 += scanlineStride, ++i) {
                for (int j = array[0]; j < array[2]; ++j) {
                    dataElements = colorModel.getDataElements(dataStorage[n7++], dataElements);
                    writableRaster.setDataElements(j, i, dataElements);
                }
            }
        }
    }
}
